#' Zero Forecaster
#'
#' Flat prediction: always forecast a serie of zeros.
#' This serie is then adjusted using the ".pjump" function (see \code{Forecaster} class).
#'
#' @usage f <- ZeroForecaster$new(pjump)
#'
#' @docType class
#' @format R6 class, inherits Forecaster
#' @aliases F_Zero
#'
ZeroForecaster = R6::R6Class("ZeroForecaster",
	inherit = Forecaster,

	public = list(
		predictShape = function(data, today, memory, horizon, ...)
			rep(0, horizon)
	)
)
